{% extends 'layouts/base_background.html' %}
{% load static %}

{% block title %} ZuLab{% endblock title %}

{% block body %} class="index-page bg-gray-200" {% endblock body %}

{% block content %}
<div class="container mt-7 ">
    <div class="row ">
        <div class="col-lg-12 mx-auto "> 
            <div class="position-relative border-radius-xl overflow-hidden shadow-lg mb-2 bg-gray-100">
                <div class="container border-bottom">
                    <div class="row py-3">
                    <div class="col-lg-8 text-start">
                        <p class="lead text-dark pt-1 mb-0">
                            <span class="badge bg-light text-dark">
                                <i class="fa fa-bar-chart"></i>
                            </span> 
                            Gráficas de <b>sistema</b>
                        </p>
                    </div>  
                    </div>
                </div>
                <div class="tab-content tab-space">
                    <div class="tab-pane active" id="preview-forms-simple"> 
                        <section>
                            <div class="container py-4" id="graficos">
                                <div class="row">
                                    <div class="col-md-6">
                                        <div class="input-group input-group-dynamic mb-4 is-filled">
                                            <label class="form-label">Fecha inicial</label>
                                            <input type="text" name="fecha" class="form-control datepicker flatpickr-input" required="" id="id_fechaini" readonly="readonly">
                                        </div>
                                    </div>
                                    <div class="col-md-6">
                                        <div class="input-group input-group-dynamic mb-4 is-filled">
                                            <label class="form-label">Fecha final</label>
                                            <input type="text" name="fecha" class="form-control datepicker flatpickr-input" required="" id="id_fechafin" readonly="readonly">
                                        </div>
                                    </div>
                                </div> 
                                <div class="row"> 
                                    <div class="row my-4">
                                        <div class="col-sm-12 col-md-12 col-lg-12 col-xl-12 mx-auto"> 
                                            <div class="card shadow mb-4">
                                                <div class="card-header py-3">
                                                    <h6 class="m-0 font-weight-bold text-primary">Comparativa de total atenciones por turnos en rango de fechas</h6>
                                                </div>
                                                <div class="card-body"> 
                                                    <div class="chart-area"> 
                                                        <canvas id="areaChart"></canvas>
                                                    </div>
                                                    <hr>
                                                    Exposción de total de atenciones registradas en todos los estudios, agrupado por turnos de atenciones en un determinado rango de fechas
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="row"> 
                                    <div class="col-lg-6 col-md-6 col-sm-12">
                                        <div class="card shadow mb-4">
                                            <div class="card-header py-3">
                                                <h6 class="m-0 font-weight-bold text-primary">Grupos de areas por cantidad de atenciones</h6>
                                            </div>
                                            <div class="card-body">
                                                <div  class="chart-bar">
                                                    <canvas id="barChartHorizontalArea"></canvas>
                                                </div>
                                                <hr>
                                                Cantidad de atenciones registradas por en rango de fechas por agrupacion de areas
                                            </div>
                                        </div> 
                                    </div> 
                                    <div class="col-lg-6 col-md-6 col-sm-12">
                                        <div class="card shadow mb-4">
                                            <div class="card-header py-3">
                                                <h6 class="m-0 font-weight-bold text-primary">Grupos de estudios por cantidad de atenciones</h6>
                                            </div>
                                            <div class="card-body">
                                                <div  class="chart-bar">
                                                    <canvas id="barChartHorizontalEst"></canvas>
                                                </div>
                                                <hr>
                                                Cantidad de atenciones registradas por en rango de fechas por agrupacion de tipo de estudios
                                            </div>
                                        </div> 
                                    </div>
                                </div>
                                <div class="row"> 
                                    <div class="col-lg-12 col-md-12 col-sm-12">
                                        <div class="card shadow mb-4">
                                            <div class="card-header py-3">
                                                <h6 class="m-0 font-weight-bold text-primary">Grupos de areas por cantidad de atenciones</h6>
                                            </div>
                                            <div class="card-body">
                                                <div  class="chart-bar">
                                                    <canvas id="polarArea" width="800" height="400"></canvas>
                                                </div>
                                                <hr>
                                                Cantidad de atenciones registradas por en rango de fechas por agrupacion de areas
                                            </div>
                                        </div> 
                                    </div>  
                                </div>
                                <div class="row">  
                                    <div class="col-lg-12 col-md-12 col-sm-12">
                                        <div class="card shadow mb-4">
                                            <div class="card-header py-3">
                                                <h6 class="m-0 font-weight-bold text-primary">Grupos de estudios por cantidad de atenciones</h6>
                                            </div>
                                            <div class="card-body">
                                                <div class="chart-view  pt-4">
                                                    <canvas id="polarEst" width="800" height="400"></canvas>
                                                </div>
                                                <hr>
                                                Cantidad de atenciones registradas por en rango de fechas por agrupacion de tipo de estudios
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div id="verticalDinamico">
                                    
                                </div> 
                            </div>
                        </section> 
                    </div> 
                </div>
            </div> 
        </div>
    </div>
</div>   
{% endblock content %}
{% block javascripts %}  
{% comment %} <script src="{% static 'vendor/chart.js/chart42.js' %}"></script>   {% endcomment %}
<script src="{% static 'js/plugins/flatpickr.min.js' %}"></script>

<script src="https://cdn.jsdelivr.net/npm/chart.js@2.9.4/dist/Chart.bundle.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/chartjs-plugin-datalabels@0.7.0"></script>

<script language="javascript">  
var auxFecha_ = new Date(); 
$(document).ready(function() { 

    var fechaActual = new Date(); 
    fechaActual.setMonth(fechaActual.getMonth() - 1); 
    var año = fechaActual.getFullYear();
    var mes = fechaActual.getMonth() + 1; // Sumamos 1 porque los meses en JavaScript van de 0 a 11
    var dia = fechaActual.getDate(); 
    var fechaMesAtras = año + '-' + (mes < 10 ? '0' : '') + mes + '-' + (dia < 10 ? '0' : '') + dia;   

    flatpickr("#id_fechaini", {defaultDate:fechaMesAtras }); 
    flatpickr("#id_fechafin", {
        defaultDate:auxFecha_, 
        onChange: function(selectedDates, dateStr, instance){ 
            actualizarInformacionChart($("#id_fechaini").val(),$("#id_fechafin").val()); 
        }
    }); 
    
    setChartArea({{ areaChartTm_arrayLabel | safe }}, {{ areaChartTm_arrayData | safe }}, {{ areaChartTt_arrayData | safe }}, {{ areaChartTn_arrayData | safe }});
    barChartArea = setBarHorz({{ barHorzTm_arrayLabel | safe }}, {{ barHorzTm_arrayData | safe }}, {{ barHorzTt_arrayData | safe }}, {{ barHorzTn_arrayData | safe }}, 'barChartHorizontalArea', barChartArea);
    barChartEst = setBarHorz({{ barHorzEst_arrayLabel | safe }}, {{ barHorzEstTm_arrayData | safe }}, {{ barHorzEstTt_arrayData | safe }}, {{ barHorzEstTn_arrayData | safe }}, 'barChartHorizontalEst', barChartEst);
    polarArea = setPolar({{ polarArea_arrayLabel | safe }}, {{ polarArea_arrayData | safe }}, 'polarArea', polarArea);
    polarEst = setPolar({{ polarEst_arrayLabel | safe }}, {{ polarEst_arrayData | safe }}, 'polarEst', polarEst);
    barCharVertical = setBarVertical({{ verticalEstudio | safe }});


});

function actualizarInformacionChart(fini, ffin){
    if(fini && ffin){
        var asoc = {fechaini:fini, fechafin: ffin};
        console.log("enviamos a servidor");
        console.log(asoc);
        $.ajax({
            headers : {"X-CSRFToken": '{{csrf_token}}'},
            type:"POST",
            url:"/chart/asincrono",
            data: JSON.stringify(asoc),
            success: function(dat){  
                console.log(asoc);
                if(dat.mensaje == 'NH'){
                    mensaje('Excepción',"No se encontro ningun registro  para el rango de fechas seleccionado.",'red');  
                }else{    
                    setChartArea(dat.areaChartTm_arrayLabel, dat.areaChartTm_arrayData, dat.areaChartTt_arrayData, dat.areaChartTn_arrayData); 
                    barChartArea =setBarHorz(dat.barHorzTm_arrayLabel , dat.barHorzTm_arrayData , dat.barHorzTt_arrayData , dat.barHorzTn_arrayData, 'barChartHorizontalArea' , barChartArea);
                    barChartEst =setBarHorz(dat.barHorzEst_arrayLabel , dat.barHorzEstTm_arrayData , dat.barHorzEstTt_arrayData , dat.barHorzEstTn_arrayData, 'barChartHorizontalEst' , barChartEst);
                    polarArea = setPolar(dat.polarArea_arrayLabel , dat.polarArea_arrayData, 'polarArea', polarArea);
                    polarEst = setPolar(dat.polarEst_arrayLabel , dat.polarEst_arrayData, 'polarEst', polarEst);  
                    barCharVertical = setBarVertical(dat.verticalEstudio);
                } 
            },
            error: function(jqXHR, textStatus, errorThrow){ 
                mensaje('Excepción',textStatus+'|'+errorThrow,'red'); 
            }
        }); 
    }
} 
function setBarVertical(verticalEstudios){
    var html = "";
    htmlCol = "";
    cnt = 0;  
    verticalEstudios.forEach(function (estudio){ 
        htmlCol =  `
            <div class="col-lg-6 col-md-6 col-sm-12">
                <div class="card shadow mb-4">
                    <div class="card-header py-3">
                        <h6 class="m-0 font-weight-bold text-primary">${estudio[1]} por cantidad de atenciones por turnos</h6>
                    </div>
                    <div class="card-body">
                        <div class="chart-view">
                            <canvas id="barChartVertical${estudio[0]}"></canvas>
                        </div> 
                    </div>
                </div>
            </div>
        `;
        if(cnt == 0 ){
            html +=`<div class="row">`;
        }
        html += htmlCol;
        if(cnt == 1 ){
            html +=`</div>`;
            cnt = 0; 
        }else{
            cnt ++;
        } 
    }); 

    $('#verticalDinamico').html(html); 
    verticalEstudios.forEach(function(estudio)
    {
        setBarVerticalGrafica(estudio) 
    });
    
} 
var barVertObj = [];
function setBarVerticalGrafica(estudio){
    ctxVert = document.getElementById("barChartVertical"+estudio[0]) 
    var label_ = [estudio[1]]; 

    var data1 = estudio[2]; 
    var data2 = estudio[3];
    var data3 = estudio[4];

    if(barVertObj[estudio[0]])
        barVertObj[estudio[0]].destroy();  
    barVertObj[estudio[0]] = new Chart(ctxVert, {
        type: 'bar',
        data: {
            labels: label_,
            datasets: [{
                axis: 'y',
                label: 'Mañana',
                backgroundColor: "rgba(255,119,146, 0.5)",
                borderColor: "rgba(255,119,146, 1)",
                data: [data1,],  
                borderWidth: 1
            },
            {
                axis: 'y',
                label: 'Tarde',
                backgroundColor: "rgba(75,191,191, 0.5)",
                borderColor: "rgb(75,191,191, 1)",
                data: [data2,],   
                borderWidth: 1
            }
            ,
            {
                axis: 'y',
                label: 'Noche',
                data: [data3,],  
                borderWidth: 1
            }
            ]
        },
        options: {
            indexAxis : 'y', 
        }
    }); 
}

var ctxareaChart = document.getElementById("areaChart");  
var areaChartObj = '';
function setChartArea(label = [], datatm = [], datatt = [], datatn = []){
    
    if(areaChartObj)
    areaChartObj.destroy();  
    areaChartObj = new Chart(ctxareaChart,{
        type: 'line',
        data: { 
            labels: label,
            datasets: [
            {
                label: "Mañana",
                lineTension: 0.3,
                backgroundColor: "rgba(255,119,146, 0.5)",
                borderColor: "rgba(255,119,146, 1)",
                borderWidth: 1,
                pointRadius: 3,
                pointBackgroundColor: "rgba(255,119,146, 1)",
                pointBorderColor: "rgba(255,119,146, 1)",
                pointHoverRadius: 3,
                pointHoverBackgroundColor: "rgba(255,119,146, 1)",
                pointHoverBorderColor: "rgba(255,119,146, 1)",
                pointHitRadius: 10,
                pointBorderWidth: 2,
                data: datatm, 
            },
            {
                label: "Tarde",
                lineTension: 0.3,
                backgroundColor: "rgba(75,191,191, 0.5)",
                borderColor: "rgb(75,191,191, 1)",
                borderWidth: 1,
                pointRadius: 3,
                pointBackgroundColor: "rgb(75,191,191, 1)",
                pointBorderColor: "rgb(75,191,191, 1)",
                pointHoverRadius: 3,
                pointHoverBackgroundColor: "rgb(75,191,191, 1)",
                pointHoverBorderColor: "rgb(75,191,191, 1)",
                pointHitRadius: 10,
                pointBorderWidth: 2,
                data:datatt, 
            },   
            {
                label: "Noche",
                lineTension: 0.3,
                backgroundColor: "rgba(177,137,255, 0.5)",
                borderColor: "rgb(177,137,255, 1)",
                borderWidth: 1,
                pointRadius: 3,
                pointBackgroundColor: "rgb(177,137,255)",
                pointBorderColor: "rgb(177,137,255, 1)",
                pointHoverRadius: 3,
                pointHoverBackgroundColor: "rgb(177,137,255)",
                pointHoverBorderColor: "rgb(177,137,255, 1)",
                pointHitRadius: 10,
                pointBorderWidth: 2,
                data:datatn, 
            },
            ],
        },
        options: {
            plugins: {
                datalabels: {
                    anchor: 'end',
                    align: 'top',
                    formatter: function(value, context) {
                        return value;
                    }
                }
            }
        } 
    });
}

var ctxbarChartHorizontal = '';
var barChartArea = '';
var barChartEst = '';
function setBarHorz(label , datatm , datatt , datatn, ctxbarChartHorizontal , barChartAux){
    if(barChartAux)
        barChartAux.destroy();  
    barChartAux = new Chart(document.getElementById(ctxbarChartHorizontal),{
        type: 'bar',
        data: {
            labels: label,
            datasets: [{
                label: "Mañana",  
                data: datatm ,
                backgroundColor: "rgba(255,119,146, 0.5)",
                borderColor: "rgba(255,119,146, 1)",
                borderWidth: 1
            },
            {
                label: "Tarde",   
                data: datatt,
                backgroundColor: "rgba(75,191,191, 0.5)",
                borderColor: "rgb(75,191,191, 1)",
                borderWidth: 1
            },
            {
                label: "Noche",   
                data: datatn,
                backgroundColor: "rgba(177,137,255, 0.5)",
                borderColor: "rgb(177,137,255, 1)",
                borderWidth: 1
            },
            ],
        }, 
        options: {
            plugins: {
                datalabels: {
                    anchor: 'end',
                    align: 'top',
                    formatter: function(value, context) {
                        return value;
                    }
                }
            }
        }  
    });
    return barChartAux;
}

const ctxPolar = '';
var polarArea = ""; 
var polarEst = ""; 
function setPolar(label, data, ctxPolar_, polarChart){
    if(polarChart)
        polarChart.destroy(); 
    polarChart = new Chart(document.getElementById(ctxPolar_), {
        type: 'polarArea',
        data: {
            labels:label,
            datasets: [{ 
                data: data, 
                backgroundColor: [
                'rgb(255, 99, 132)',
                'rgb(75, 192, 192)',
                'rgb(255, 205, 86)',
                'rgb(201, 203, 207)',
                'rgb(54, 162, 235)',
                'rgb(177,137,255)',
                'rgb(255, 0, 0)',        
                'rgb(0, 255, 0)',         
                'rgb(0, 0, 255)'          
                    ],
            }]
        }, 
        options: {
            plugins: {
                datalabels: {
                    anchor: 'end',
                    align: 'top',
                    formatter: function(value, context) {
                        return value;
                    }
                }
            }
        } 
    });
    return polarChart;
}
function numerosRandom(){
        var numeros = [];
    for (let i = 0; i < 52; i++) {
        // Genera un número aleatorio entre 10 y 50
        let numeroAleatorio = Math.floor(Math.random() * (50 - 10 + 1)) + 10;
        numeros.push(numeroAleatorio);
    }
    return numeros;
} 
function number_format(number, decimals, dec_point, thousands_sep) { 
    number = (number + '').replace(',', '').replace(' ', '');
    var n = !isFinite(+number) ? 0 : +number,
        prec = !isFinite(+decimals) ? 0 : Math.abs(decimals),
        sep = (typeof thousands_sep === 'undefined') ? ',' : thousands_sep,
        dec = (typeof dec_point === 'undefined') ? '.' : dec_point,
        s = '',
        toFixedFix = function(n, prec) {
            var k = Math.pow(10, prec);
            return '' + Math.round(n * k) / k;
        }; 
        s = (prec ? toFixedFix(n, prec) : '' + Math.round(n)).split('.');
        if (s[0].length > 3) {
        s[0] = s[0].replace(/\B(?=(?:\d{3})+(?!\d))/g, sep);
        }
        if ((s[1] || '').length < prec) {
        s[1] = s[1] || '';
        s[1] += new Array(prec - s[1].length + 1).join('0');
        }
        return s.join(dec);
}
</script>    
{% endblock javascripts %}

